#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#define ALLIES	2
#define AXIS	3
#define PLUGIN_VERSION "3.8"

new g_iAmmo[MAXPLAYERS + 1];
new g_iAmount[MAXPLAYERS + 1];
new g_iClip;
new g_iLevel[MAXPLAYERS + 1] =  { 1, ... };
new g_iLevels;
new g_iOffset;
new g_ggWinner = -1;
new g_iOldLevel[MAXPLAYERS + 1] =  { 1, ... };
new g_iWeapon[MAXPLAYERS + 1] =  { -1, ... };
new g_teamvalueALL = 0;
new g_teamvalueAXIS = 0;
new g_teamvalueALLIES = 0;
new g_spaderoundinfo = 1; // controls spaderound info
new spadecounter = 0; // set to 1 when spaderound begins
new g_gameframe = 0;
new g_liveinfo = 0; // controls live view
new Handle:g_bonustime = INVALID_HANDLE;
new Handle:g_nogameend = INVALID_HANDLE;
new Handle:g_nades = INVALID_HANDLE;
new Handle:g_flagcapture = INVALID_HANDLE;
new Handle:g_wincommand = INVALID_HANDLE;
new Handle:g_warmuptime = INVALID_HANDLE;
new Handle:g_runspeed = INVALID_HANDLE;
new Handle:g_health = INVALID_HANDLE;
new Handle:g_TeamLockGG = INVALID_HANDLE;
new Handle:g_CPdisable = INVALID_HANDLE;
new Handle:g_WallRemove = INVALID_HANDLE;
new Handle:g_killpoints = INVALID_HANDLE;
new Handle:g_killpointsTK = INVALID_HANDLE;
new Handle:g_kpmax = INVALID_HANDLE;
new Handle:g_kpmaxspade = INVALID_HANDLE;
new Handle:g_kpspade = INVALID_HANDLE;
new String:g_sPrefix[24] = "\x05GG TDM\x01";
new String:g_sSoundJoin[PLATFORM_MAX_PATH];
new String:g_sSoundLevelUp[PLATFORM_MAX_PATH];
new String:g_sSoundLevelDown[PLATFORM_MAX_PATH];
new String:g_sSoundLevelSteal[PLATFORM_MAX_PATH];
new String:g_sSoundWin[PLATFORM_MAX_PATH];
new String:g_sSoundspade[PLATFORM_MAX_PATH];
new String:g_sSoundLevelLast[PLATFORM_MAX_PATH];
new String:g_sWeapon[MAXPLAYERS + 1][16];
new String:FlagSnd[] = "ambient/flag.wav";
new bool:IsProtected[MAXPLAYERS + 1] = false;
new bool:g_bEnabled = true;
new Float:g_fPosition[MAXPLAYERS + 1][3];
new Float:rint; // for Dogs DODsBots
new g_WeaponParent;

new bool:LogEnable = false; // Enable logging of kills (true or false)

static const String:g_szObjectives[][] =  { "dod_bomb_target", "dod_capture_area" };
static const String:g_szTeamWalls[][] =  { "func_team_wall", "func_teamblocker" };

public Plugin:myinfo =  {
	name = "DoD:S TDM GunGame", 
	author = "Darkranger", 
	description = "DoD:S TDM GunGame for SourceMod", 
	version = PLUGIN_VERSION, 
	url = "http://dark.asmodis.at"
}

#include "dod_tdm_gungame3.8\drawmenu.sp"
#include "dod_tdm_gungame3.8\gameend.sp"
#include "dod_tdm_gungame3.8\loadconfig.sp"
#include "dod_tdm_gungame3.8\playerclass.sp"

public OnPluginStart()
{
	CreateConVar("dods_tdm_gungame", PLUGIN_VERSION, "DoD:S TDM GunGame", FCVAR_PLUGIN | FCVAR_REPLICATED | FCVAR_NOTIFY | FCVAR_DONTRECORD);
	g_bonustime = CreateConVar("dods_tdm_gungame_bonustime", "30", "Length of Bonusround", FCVAR_PLUGIN, true, 20.0, true, 400.0);
	g_nogameend = CreateConVar("dods_tdm_gungame_gameend", "1", "(1) Enable GameEnd / (0) Disable GameEnd (disables also length of bonusround. so there is no end of the map", FCVAR_PLUGIN);
	g_warmuptime = CreateConVar("dods_tdm_gungame_warmup", "30", "Length of WarmUp Round in Seconds", FCVAR_PLUGIN, true, 20.0, true, 300.0);
	g_nades = CreateConVar("dods_tdm_gungame_maxnades", "10", "How many frag grenades are allowed", FCVAR_PLUGIN, true, 1.0, true, 99.0);
	g_runspeed = CreateConVar("dods_tdm_gungame_speed", "1.1", "Speed on spade Level", FCVAR_PLUGIN, true, 1.0, true, 1.3);
	g_health = CreateConVar("dods_tdm_gungame_health", "110", "Health on Spade Level", FCVAR_PLUGIN, true, 80.0, true, 160.0);
	g_kpmax = CreateConVar("dods_tdm_gungame_maxpoint", "1500", "Points to win the Round", FCVAR_PLUGIN, true, 80.0, true, 20000.0);
	g_kpmaxspade = CreateConVar("dods_tdm_gungame_spademode", "1200", "Points when Teams got spades", FCVAR_PLUGIN, true, 70.0, true, 19000.0);
	g_killpoints = CreateConVar("dods_tdm_gungame_point", "10", "Points for Kill", FCVAR_PLUGIN, true, 1.0, true, 80.0);
	g_killpointsTK = CreateConVar("dods_tdm_gungame_points_teamkill", "15", "Points lost for TeamKill", FCVAR_PLUGIN, true, 1.0, true, 80.0);
	g_kpspade = CreateConVar("dods_tdm_gungame_pointspadekill", "20", "Points for Kill with Spade", FCVAR_PLUGIN, true, 1.0, true, 100.0);
	g_TeamLockGG = CreateConVar("dods_tdm_gungame_teamlock", "1", "Enable/disable autojoin class when selected a Team", FCVAR_PLUGIN);
	g_CPdisable = CreateConVar("dods_tdm_gungame_cpdisable", "1", "Enable(0)/disable(1) Control Point Icons, Flags and FlagSound", FCVAR_PLUGIN);
	g_flagcapture = CreateConVar("dods_tdm_gungame_capture_points", "40", "Points for capturing Flags", FCVAR_PLUGIN, true, 1.0, true, 100.0);
	g_WallRemove = CreateConVar("dods_tdm_gungame_teamwallremove", "1", "Enable/disable removing func_team_walls during Game", FCVAR_PLUGIN);
	g_wincommand = CreateConVar("dods_tdm_gungame_wincommand", "sm_mapvote", "ServerCommand that will be executed 15 seconds after win", FCVAR_PLUGIN);
	g_iClip = FindSendPropInfo("CBaseCombatWeapon", "m_iClip1");
	g_iOffset = FindSendPropInfo("CBasePlayer", "m_iAmmo");
	HookEvent("dod_round_start", Event_RoundStart);
	HookEvent("dod_warmup_ends", Event_WarmUpEnd);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("dod_point_captured", Event_Capture);
	HookEvent("player_team", Event_PlayerTeam, EventHookMode_Post);
	g_WeaponParent = FindSendPropOffs("CBaseCombatWeapon", "m_hOwnerEntity");
	RegConsoleCmd("drop", Command_Drop, "Block weapons from being dropped in DoD:S GunGame.");
	AutoExecConfig(true, "dod_tdm_gungame_config", "dod_tdm_gungame_config");
	LoadTranslations("dod_tdm_gungame.phrases");
	AddAmbientSoundHook(AmbientSHook:HookFlagSound);
	RegConsoleCmd("sc", Show_ggScores);
	RegConsoleCmd("ggtdm", Show_ggInfo);
	AddCommandListener(OnPlayerChat, "say");
	AddCommandListener(OnPlayerChat, "say_team");
}

public Action:OnPlayerChat(client, const String:command[], args)
{
	if (args == 0)return Plugin_Continue;
	decl String:text[13];
	GetCmdArg(1, text, sizeof(text));
	if (StrEqual(text, "sc", false) || StrEqual(text, "SC", false))
	{
		Show_ggScores(client, args);
	}
	if (StrEqual(text, "ggtdm", false) || StrEqual(text, "GGTDM", false))
	{
		Show_ggInfo(client, args);
		LogMessage("DoDs GG TDM Player %N take a look at INFOSCREEN", client);
		
	}
	return Plugin_Continue;
}

public OnClientPutInServer(client)
{
	g_iLevel[client] = 1;
	g_iOldLevel[client] = 1;
	CreateTimer(12.0, Show_ggInfoClient, client, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(15.0, Announceggtdmhelp, client, TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(30.0, Announceggtdmhelp, client, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Announceggtdmhelp(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		PrintToChat(client, "\x07FFFF00%t", "announce");
	}
}

public OnMapStart()
{
	g_ggWinner = -1;
	g_teamvalueAXIS = 0;
	g_teamvalueALLIES = 0;
	g_teamvalueALL = 0;
	g_liveinfo = 0;
	spadecounter = 0;
	LoadConfig();
	PrecacheSound(FlagSnd, true);
	g_spaderoundinfo = 1;
	// SOME Server commands
	ServerCommand("dod_freezecam 0");
	ServerCommand("mp_limit_allies_rifleman -1");
	ServerCommand("mp_limit_axis_rifleman -1");
}

public OnRoundStart()
{
	RemoveFlagSound();
}

public Action:Event_WarmUpEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	g_ggWinner = -1;
	g_teamvalueAXIS = 0;
	g_teamvalueALLIES = 0;
	g_teamvalueALL = 1;
	g_liveinfo = 1;
	spadecounter = 0;
	PrintCenterTextAll("%t", "warmup");
	ServerCommand("dod_freezecam 0");
	
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			g_iLevel[client] = 1;
			g_iOldLevel[client] = 1;
			g_iWeapon[client] = -1;
			PrintHintText(client, "%t", "warmup");
			PrintToChat(client, "%t", "warmup");
		}
	}
}

public OnConfigsExecuted()
{
	LoadConfig2();
	ServerCommand("mp_warmup_time %i", GetConVarInt(g_warmuptime));
	ServerCommand("dod_freezecam 0");
}

public OnClientDisconnect(client)
{
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if ((g_liveinfo == 2) || (g_liveinfo == 3))
	{
		buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flStamina", 100.0):0;
		buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", GetConVarFloat(g_runspeed)):0;
	}
}

public OnGameFrame()
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		for (new i = 1, iAmmo, iAmount; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i) && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_ger") && !StrEqual(g_sWeapon[g_iLevel[i]], "frag_us"))
			{
				if (!StrEqual(g_sWeapon[g_iLevel[i]], "spade"))
				{
					iAmmo = g_iAmmo[GetLevel(i)], iAmount = g_iAmount[i];
					if (iAmmo > g_iOffset && GetEntData(i, iAmmo) <= iAmount)
					{
						SetEntData(i, iAmmo, iAmount * 2, _, true);
					}
				}
			}
		}
	}
	
	if (g_gameframe == 33)
	{
		if (g_liveinfo == 0)
		{
			PrintHintTextToAll("WARMUP MODE");
		}
		if (g_liveinfo == 1)
		{
			PrintHintTextToAll("%t", "livestandings", g_teamvalueAXIS, g_teamvalueALLIES);
		}
		if (g_liveinfo == 2)
		{
			PrintHintTextToAll("%t", "livestandingsspade", g_teamvalueAXIS, g_teamvalueALLIES);
		}
		if (g_liveinfo == 3)
		{
			PrintHintTextToAll("%t", "livestandingswin", g_teamvalueAXIS, g_teamvalueALLIES);
		}
		g_gameframe = 0;
	}
	g_gameframe++;
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled)
	{
		new iClient = GetClientOfUserId(GetEventInt(event, "userid"));
		if (IsFakeClient(iClient))
		{
			CleanUp();
		}
		// SPADE ROUND
		if ((GetClientTeam(iClient) > 1) && (spadecounter == 1) && (!IsFakeClient(iClient)))
		{
			for (new i = 0, s; i < 5; i++)
			{
				if ((s = GetPlayerWeaponSlot(iClient, i)) != -1)
				{
					RemoveWeapon(iClient, s);
				}
			}
			GivePlayerItem(iClient, "weapon_spade");
			return;
		}
		// BOTS SPADE
		if (IsClientInGame(iClient) && IsPlayerAlive(iClient) && IsClientConnected(iClient) && IsFakeClient(iClient) && (spadecounter == 1))
		{
			rint = GetRandomFloat(0.5, 2.2);
			CreateTimer((rint), BOTTimerGive, iClient, TIMER_FLAG_NO_MAPCHANGE);
		}
		
		//NORMAL ROUND
		if ((GetClientTeam(iClient) > 1) && (spadecounter == 0))
		{
			GetClientAbsOrigin(iClient, g_fPosition[iClient]);
			for (new i = 0, s; i < 5; i++)
			{
				if ((s = GetPlayerWeaponSlot(iClient, i)) != -1)
				{
					RemoveWeapon(iClient, s);
				}
			}
			if (g_ggWinner != -1)
			{
				GivePlayerItem(iClient, "weapon_spade");
				return;
			}
			new iLevel = g_iLevel[iClient];
			g_iWeapon[iClient] = -1;
			if ((IsClientInGame(iClient)) && (IsPlayerAlive(iClient)))
			{
				{
					GiveWeapon(iClient);
				}
			}
			if (!StrEqual(g_sWeapon[iLevel], "spade") && (IsClientInGame(iClient)))
			{
				GivePlayerItem(iClient, "weapon_spade");
			}
		}
	}
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (g_bEnabled && g_ggWinner == -1)
	{
		decl Float:fPosition[3], String:sWeapon[16];
		new iAttackerID = GetEventInt(event, "attacker"), 
		iClientID = GetEventInt(event, "userid"), 
		iAttacker = GetClientOfUserId(iAttackerID), 
		iClient = GetClientOfUserId(iClientID);
		GetClientAbsOrigin(iClient, fPosition);
		GetEventString(event, "weapon", sWeapon, sizeof(sWeapon));
		
		
		if (spadecounter == 0)
		{
			if (IsValidEntity(g_iWeapon[iClient]))
			{
				RemoveWeapon(iClient, g_iWeapon[iClient]);
			}
			if (iAttacker == 0 || iAttacker == iClient)
			{
				if (g_iLevel[iClient] > 1)
				{
					g_iLevel[iClient]--;
					if (!StrEqual(g_sSoundLevelDown, ""))
					{
						EmitSoundToClient(iClient, g_sSoundLevelDown);
					}
				}
			}
			else if (GetClientTeam(iAttacker) == GetClientTeam(iClient))
			{
				new iTeam = GetClientTeam(iAttacker);
				if (IsClientInGame(iAttacker) && IsPlayerAlive(iAttacker))
				{
					if (g_iLevel[iAttacker] > 1)
					{
						g_iLevel[iAttacker]--;
						if (!StrEqual(g_sSoundLevelDown, ""))
						{
							EmitSoundToClient(iAttacker, g_sSoundLevelDown);
						}
						// TEAMKILL
						if ((iTeam == ALLIES) && (g_teamvalueALL > 0))
						{
							g_teamvalueALLIES = (g_teamvalueALLIES - GetConVarInt(g_killpointsTK));
							PrintToChat(iAttacker, "%t", "lostpointfortk", g_sPrefix, GetConVarInt(g_killpointsTK));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM ALLIES TEAMKILL from %N: STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						if ((iTeam == AXIS) && (g_teamvalueALL > 0))
						{
							g_teamvalueAXIS = (g_teamvalueAXIS - GetConVarInt(g_killpointsTK));
							PrintToChat(iAttacker, "%t", "lostpointfortk", g_sPrefix, GetConVarInt(g_killpointsTK));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM AXIS TEAMKILL from %N: STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
					}
				}
			}
			// KILL ENEMY
			else if (GetClientTeam(iAttacker) != GetClientTeam(iClient) && (StrEqual(sWeapon, g_sWeapon[GetLevel(iAttacker)]) || StrEqual(sWeapon, "spade")))
			{
				new iTeam = GetClientTeam(iAttacker);
				if (fPosition[0] == g_fPosition[iClient][0] && fPosition[1] == g_fPosition[iClient][1])
				{
					PrintHintText(iAttacker, "%t", "AFK", iClient);
				}
				else if (g_iLevel[iAttacker]++ < g_iLevels)
				{
					// SPADE KILL LEVEL STEAL
					if (StrEqual(sWeapon, "spade") && g_iLevel[iClient] > 1)
					{
						g_iLevel[iClient]--;
						if ((iTeam == ALLIES) && (g_teamvalueALL > 0))
						{
							g_teamvalueALLIES = (g_teamvalueALLIES + GetConVarInt(g_kpspade));
							PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM ALLIES SPADEKILL from: %N STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						if ((iTeam == AXIS) && (g_teamvalueALL > 0))
						{
							g_teamvalueAXIS = (g_teamvalueAXIS + GetConVarInt(g_kpspade));
							PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM AXIS SPADEKILL from: %N STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						
						if (!StrEqual(g_sSoundLevelSteal, ""))
						{
							EmitSoundToClient(iAttacker, g_sSoundLevelSteal);
						}
						if (!StrEqual(g_sSoundLevelDown, ""))
						{
							EmitSoundToClient(iClient, g_sSoundLevelDown);
						}
						if (g_iLevel[iAttacker] == g_iLevels)
						{
							g_iOldLevel[iAttacker] = 1;
							g_iLevel[iAttacker] = 1;
							GiveWeapon(iAttacker);
						}
					}
					else
					{
						if (!StrEqual(g_sSoundLevelUp, ""))
						{
							EmitSoundToClient(iAttacker, g_sSoundLevelUp);
						}
						LogEvent("gg_levelup", iAttackerID);
						
						if ((iTeam == ALLIES) && (g_teamvalueALL > 0))
						{
							if (StrEqual(sWeapon, g_sWeapon[GetLevel(iAttacker)]) || StrEqual(sWeapon, "spade"))
							{
								// SPADEKILL
								g_teamvalueALLIES = (g_teamvalueALLIES + GetConVarInt(g_kpspade));
								PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
								if (LogEnable)
								{
									LogMessage("DoDs GG TDM ALLIES SPADEKILL2 from %N: STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
								}
							}
							else
							{
								// NORMALKILL
								g_teamvalueALLIES = (g_teamvalueALLIES + GetConVarInt(g_killpoints));
								PrintToChat(iAttacker, "%t", "scorepoint", g_sPrefix, GetConVarInt(g_killpoints));
								if (LogEnable)
								{
									LogMessage("DoDs GG TDM ALLIES KILL from %N: STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
								}
							}
						}
						
						if ((iTeam == AXIS) && (g_teamvalueALL > 0))
						{
							if (StrEqual(sWeapon, g_sWeapon[GetLevel(iAttacker)]) || StrEqual(sWeapon, "spade"))
							{
								// SPADEKILL
								g_teamvalueAXIS = (g_teamvalueAXIS + GetConVarInt(g_kpspade));
								PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
								if (LogEnable)
								{
									LogMessage("DoDs GG TDM AXIS SPADEKILL2 from: %N STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
								}
							}
							else
							{
								// NORMALKILL
								g_teamvalueAXIS = (g_teamvalueAXIS + GetConVarInt(g_killpoints));
								PrintToChat(iAttacker, "%t", "scorepoint", g_sPrefix, GetConVarInt(g_killpoints));
								if (LogEnable)
								{
									LogMessage("DoDs GG TDM AXIS KILL from: %N STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
								}
							}
						}
						
						if (g_iLevel[iAttacker] == g_iLevels)
						{
							g_iOldLevel[iAttacker] = 1;
							g_iLevel[iAttacker] = 1;
							GiveWeapon(iAttacker);
						}
					}
					CreateTimer(0.2, Timer_Give, iAttacker, TIMER_FLAG_NO_MAPCHANGE);
				}
				if (((g_teamvalueAXIS) >= (GetConVarInt(g_kpmaxspade))) || ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmaxspade))))
				{
					// GIVE ALL THE SPADE
					if (spadecounter == 0)
					{
						for (new client = 1; client <= MaxClients; client++)
						{
							if (IsClientInGame(client) && IsPlayerAlive(client) && (!IsFakeClient(client)))
							{
								for (new i = 0, s; i < 5; i++)
								{
									if ((s = GetPlayerWeaponSlot(client, i)) != -1)
									{
										RemoveWeapon(client, s);
									}
								}
								GivePlayerItem(client, "weapon_spade");
							}
						}
						// BOTS SPADE
						for (new client = 1; client <= MaxClients; client++)
						{
							if (IsClientInGame(client) && IsPlayerAlive(client) && IsClientConnected(client) && IsFakeClient(client))
							{
								rint = GetRandomFloat(0.5, 3.0);
								CreateTimer((rint), BOTTimerGive, client, TIMER_FLAG_NO_MAPCHANGE);
							}
						}
						spadecounter = 1;
					}
					if (g_spaderoundinfo > 0)
					{
						PrintToChatAll("%t", "spaderound");
						PrintCenterTextAll("%t", "spaderound");
						g_spaderoundinfo = 0;
						if (!StrEqual(g_sSoundspade, ""))
						{
							EmitSoundToAll(g_sSoundspade);
						}
						g_liveinfo = 2;
						if (GetConVarInt(g_CPdisable) == 1)
						{
							LogEvent("gg_tdm_spaderound", iAttackerID);
							LogMessage("DoDs GG TDM SPADEROUND KILL1 from %N ", iAttacker);
						}
					}
				}
				if (((g_teamvalueAXIS) >= (GetConVarInt(g_kpmax))) || ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmax))))
				{
					g_ggWinner = iAttacker;
					if (GetConVarInt(g_CPdisable) == 1)
					{
						LogEvent("gg_tdm_win", iAttackerID);
						LogMessage("DoDs GG TDM WIN KILL from %N ", iAttacker);
					}
					if ((g_teamvalueAXIS) >= (GetConVarInt(g_kpmax)))
					{
						Show_ggWinner(iAttacker); // AXIS
					}
					if ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmax)))
					{
						Show_ggWinner2(iAttacker); // ALLIES
					}
					g_liveinfo = 3;
					CreateTimer(15.0, Run_ServerCommand, TIMER_FLAG_NO_MAPCHANGE);
					LogMessage("DoDs GG TDM FINAL POINTS: AXIS: %i - ALLIES: %i", g_teamvalueAXIS, g_teamvalueALLIES);
					if (GetConVarInt(g_nogameend) == 1)
					{
						CreateTimer(GetConVarFloat(g_bonustime), Timer_EndGame, TIMER_FLAG_NO_MAPCHANGE);
					}
					if (!StrEqual(g_sSoundWin, ""))
					{
						EmitSoundToAll(g_sSoundWin);
					}
					for (new client = 1; client <= MaxClients; client++)
					{
						if (IsClientInGame(client) && IsPlayerAlive(client) && (!IsFakeClient(client)))
						{
							for (new i = 0, s; i < 5; i++)
							{
								if ((s = GetPlayerWeaponSlot(client, i)) != -1)
								{
									RemoveWeapon(client, s);
								}
							}
						}
						GivePlayerItem(client, "weapon_spade");
						if (IsClientInGame(client) && IsPlayerAlive(client) && IsFakeClient(client))
						{
							KickClient(client);
						}
					}
					// KICK BOTS FROM SPEC
					for (new client = 1; client <= MaxClients; client++)
					{
						if (IsClientInGame(client) && IsFakeClient(client))
						{
							KickClient(client);
						}
					}
					// BOTS SPADE
					//for(new client = 1; client <= MaxClients; client++)
					//{
					//	if(IsClientInGame(client) && IsPlayerAlive(client) && IsClientConnected(client) && IsFakeClient(client))
					//	{
					//		rint = GetRandomFloat(0.5 , 3.0);
					//		CreateTimer((rint), BOTTimerGive, client, TIMER_FLAG_NO_MAPCHANGE);
					//	}
					//}
				}
			}
		}
		//SPADEROUND
		if (spadecounter == 1)
		{
			if (GetClientTeam(iAttacker) != GetClientTeam(iClient) && IsValidClient(iAttacker) && IsValidClient(iClient))
			{
				new iTeam = GetClientTeam(iAttacker);
				if (fPosition[0] == g_fPosition[iClient][0] && fPosition[1] == g_fPosition[iClient][1])
				{
					PrintHintText(iAttacker, "%t", "AFK", iClient);
				}
				else if (g_iLevel[iAttacker]++ < g_iLevels)
				{
					// SPADE KILL
					if (StrEqual(sWeapon, "spade") && g_iLevel[iClient] > 1)
					{
						if (!StrEqual(g_sSoundLevelUp, ""))
						{
							EmitSoundToClient(iAttacker, g_sSoundLevelUp);
						}
						LogEvent("gg_levelup", iAttackerID);
						
						if ((iTeam == ALLIES) && (g_teamvalueALL > 0))
						{
							// SPADEKILL
							g_teamvalueALLIES = (g_teamvalueALLIES + GetConVarInt(g_kpspade));
							PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM ALLIES SPADEROUNDKILL from: %N - STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						if ((iTeam == AXIS) && (g_teamvalueALL > 0))
						{
							// SPADEKILL
							g_teamvalueAXIS = (g_teamvalueAXIS + GetConVarInt(g_kpspade));
							PrintToChat(iAttacker, "%t", "scorepointspade", g_sPrefix, GetConVarInt(g_kpspade));
							if (LogEnable)
							{
								LogMessage("DoDs GG TDM AXIS SPADEROUNDKILL from: %N - STANDINGS: AXIS: %i - ALLIES: %i", iAttacker, g_teamvalueAXIS, g_teamvalueALLIES);
							}
						}
						if (g_iLevel[iAttacker] == g_iLevels)
						{
							g_iOldLevel[iAttacker] = 1;
							g_iLevel[iAttacker] = 1;
							GiveWeapon(iAttacker);
						}
					}
				}
				if (g_spaderoundinfo > 0)
				{
					PrintToChatAll("%t", "spaderound");
					PrintCenterTextAll("%t", "spaderound");
					g_spaderoundinfo = 0;
					if (!StrEqual(g_sSoundspade, ""))
					{
						EmitSoundToAll(g_sSoundspade);
					}
					g_liveinfo = 2;
					if (GetConVarInt(g_CPdisable) == 1)
					{
						LogEvent("gg_tdm_spaderound", iAttackerID);
						LogMessage("DoDs GG TDM SPADEROUND KILL2 from %N ", iAttacker);
					}
				}
				if (((g_teamvalueAXIS) >= (GetConVarInt(g_kpmax))) || ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmax))))
				{
					g_ggWinner = iAttacker;
					if (GetConVarInt(g_CPdisable) == 1)
					{
						LogEvent("gg_tdm_win", iAttackerID);
						LogMessage("DoDs GG TDM WIN KILL from %N ", iAttacker);
					}
					if ((g_teamvalueAXIS) >= (GetConVarInt(g_kpmax)))
					{
						Show_ggWinner(iAttacker); // AXIS
					}
					if ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmax)))
					{
						Show_ggWinner2(iAttacker); // ALLIES
					}
					g_liveinfo = 3;
					CreateTimer(15.0, Run_ServerCommand, TIMER_FLAG_NO_MAPCHANGE);
					LogMessage("DoDs GG TDM FINAL POINTS: AXIS: %i - ALLIES: %i", g_teamvalueAXIS, g_teamvalueALLIES);
					if (GetConVarInt(g_nogameend) == 1)
					{
						CreateTimer(GetConVarFloat(g_bonustime), Timer_EndGame, TIMER_FLAG_NO_MAPCHANGE);
					}
					if (!StrEqual(g_sSoundWin, ""))
					{
						EmitSoundToAll(g_sSoundWin);
					}
					for (new client = 1; client <= MaxClients; client++)
					{
						if (IsClientInGame(client) && IsPlayerAlive(client) && (!IsFakeClient(client)))
						{
							for (new i = 0, s; i < 5; i++)
							{
								if ((s = GetPlayerWeaponSlot(client, i)) != -1)
								{
									RemoveWeapon(client, s);
								}
							}
							GivePlayerItem(client, "weapon_spade");
						}
					}
				}
			}
		}
	}
	
	
	
}

public OnClientPostAdminCheck(client)
{
	IsProtected[client] = false;
	if (g_bEnabled && g_ggWinner == -1 && !StrEqual(g_sSoundJoin, ""))
	{
		EmitSoundToClient(client, g_sSoundJoin);
	}
	g_iLevel[client] = 1;
	g_iOldLevel[client] = 1;
}

public MenuHandler_Give(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		GiveWeapon(param1);
	}
}

public Action:Command_Drop(client, args)
{
	return g_bEnabled ? Plugin_Handled : Plugin_Continue;
}

public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	new entity = -1;
	if (GetConVarInt(g_CPdisable) == 1)
	{
		for (new i = 0; i < sizeof(g_szObjectives); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szObjectives[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
		entity = -1;
		while ((entity = FindEntityByClassname(entity, "dod_control_point")) != -1)
		{
			AcceptEntityInput(entity, "HideModel");
		}
	}
	if (GetConVarInt(g_WallRemove) == 1)
	{
		entity = -1;
		for (new i = 0; i < sizeof(g_szTeamWalls); i++)
		{
			while ((entity = FindEntityByClassname(entity, g_szTeamWalls[i])) != -1)
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:Timer_Give(Handle:timer, any:client)
{
	if (((g_teamvalueAXIS) <= (GetConVarInt(g_kpmaxspade))) || ((g_teamvalueALLIES) <= (GetConVarInt(g_kpmaxspade))))
	{
		GiveWeapon(client);
	}
	else
	{
		GivePlayerItem(client, "weapon_spade");
	}
}

public Action:BOTTimerGive(Handle:timer, any:client)
{
	if (IsClientInGame(client) && IsPlayerAlive(client) && IsClientConnected(client) && IsFakeClient(client))
	{
		for (new i = 0, s; i < 5; i++)
		{
			if ((s = GetPlayerWeaponSlot(client, i)) != -1)
			{
				RemoveWeapon(client, s);
			}
		}
		GivePlayerItem(client, "weapon_spade");
	}
	CleanUp();
}

GiveWeapon(iClient)
{
	decl iWeapon, String:sWeapon[24];
	new iLevel = g_iOldLevel[iClient] = g_iLevel[iClient];
	Format(sWeapon, sizeof(sWeapon), "weapon_%s", g_sWeapon[iLevel]);
	
	if (((g_teamvalueAXIS) >= (GetConVarInt(g_kpmaxspade))) || ((g_teamvalueALLIES) >= (GetConVarInt(g_kpmaxspade))))
	{
		for (new i = 0, s; i < 5; i++)
		{
			if ((s = GetPlayerWeaponSlot(iClient, i)) != -1)
			{
				RemoveWeapon(iClient, s);
			}
		}
		GivePlayerItem(iClient, "weapon_spade");
		return;
	}
	
	if (IsValidEntity(g_iWeapon[iClient]))
	{
		RemoveWeapon(iClient, g_iWeapon[iClient]);
	}
	iWeapon = GetPlayerWeaponSlot(iClient, 2);
	if (iWeapon != -1 && StrEqual(g_sWeapon[iLevel], "spade"))
	{
		RemoveWeapon(iClient, iWeapon);
	}
	g_iWeapon[iClient] = GivePlayerItem(iClient, sWeapon);
	if (StrEqual(g_sWeapon[iLevel], "frag_ger") || StrEqual(g_sWeapon[iLevel], "frag_us"))
	{
		SetEntData(iClient, g_iAmmo[iLevel], GetConVarInt(g_nades), _, true);
		PrintHintText(iClient, "%t", "grenades", g_sPrefix, GetConVarInt(g_nades));
		PrintToChat(iClient, "%t", "grenades", g_sPrefix, GetConVarInt(g_nades));
	}
	else if (StrEqual(g_sWeapon[iLevel], "spade"))
	{
		SetEntityHealth(iClient, GetConVarInt(g_health));
		//PrintToChat(iClient, "%t", "spadeknifehealth2", g_sPrefix, GetConVarInt(g_health));
	}
	else
	{
		if (IsValidEntity(g_iWeapon[iClient]))
		{
			
			if ((g_iAmount[iClient] = GetEntData(g_iWeapon[iClient], g_iClip)) < 1)
			{
				g_iAmount[iClient] = 1;
			}
			if (g_iAmmo[iLevel] > 0)
			{
				SetEntData(iClient, g_iAmmo[iLevel], g_iAmount[iClient] * 2, _, true);
			}
		}
		else
		{
			CreateTimer(0.1, NoWeaponCheck_CLIP, iClient, TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

GetLevel(iClient)
{
	return g_iLevel[iClient];
}

RemoveWeapon(iClient, iWeapon)
{
	if (IsValidEdict(iWeapon))
	{
		RemovePlayerItem(iClient, iWeapon);
		//RemoveEdict(iWeapon);
		AcceptEntityInput(iWeapon, "kill");
	}
}

RemoveFlagSound()
{
	if (GetConVarInt(g_CPdisable) == 1)
	{
		static soundOffset;
		new entity = -1;
		while ((entity = FindEntityByClassname(entity, "ambient_generic")) != -1)
		{
			if (!soundOffset && (soundOffset = FindDataMapOffs(entity, "m_iszSound")) == -1)
			{
				LogError("Error: Unable to find datamap offset: \"m_iszSound\"!");
				return;
			}
			decl String:sound[64];
			GetEntDataString(entity, soundOffset, sound, sizeof(sound));
			if (StrEqual(sound, FlagSnd))
			{
				AcceptEntityInput(entity, "Kill");
			}
		}
	}
}

public Action:HookFlagSound(String:sample[PLATFORM_MAX_PATH], &entity, &Float:volume, &level, &pitch, Float:pos[3], &flags, &Float:delay)
{
	if (StrEqual(sample, FlagSnd))
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public OnPluginEnd()
{
	
}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", Event_PlayerSpawn);
	UnhookEvent("player_death", Event_PlayerDeath);
	UnhookEvent("dod_round_start", Event_RoundStart);
	UnhookEvent("dod_warmup_ends", Event_WarmUpEnd);
	UnhookEvent("dod_point_captured", Event_Capture);
}

public Action:Run_ServerCommand(Handle:timer)
{
	decl String:wincommand[256];
	GetConVarString(g_wincommand, wincommand, sizeof(wincommand));
	ServerCommand("%s", wincommand);
}

LogEvent(const String:sName[], iUserID)
{
	decl String:sAuth[32];
	new iClient = GetClientOfUserId(iUserID);
	decl String:sTeam[32];
	if (GetClientTeam(iClient) == 2)
	{
		Format(sTeam, sizeof(sTeam), "Allies");
	}
	else
	{
		Format(sTeam, sizeof(sTeam), "Axis");
	}
	GetClientAuthString(iClient, sAuth, sizeof(sAuth));
	LogToGame("\"%N<%d><%s><%s>\" triggered \"%s\"", iClient, iUserID, sAuth, sTeam, sName);
}

public Action:Event_Capture(Handle:event, const String:name[], bool:dontBroadcast)
{
	if ((GetConVarInt(g_CPdisable) == 0) && (GetConVarInt(g_flagcapture) > 0) && (g_liveinfo < 3))
	{
		//PrintToChatAll("FLAG CAPTURED");
		new iTeam = 0;
		new String:cappers[256];
		GetEventString(event, "cappers", cappers, sizeof(cappers));
		for (new i = 0; i < strlen(cappers); i++)
		{
			new client = cappers { i };
			iTeam = GetClientTeam(client);
		}
		if ((iTeam == AXIS) && (g_teamvalueALL > 0))
		{
			g_teamvalueAXIS = (g_teamvalueAXIS + GetConVarInt(g_flagcapture));
			PrintToChatAll("%t", "flagcap_axis", g_sPrefix, GetConVarInt(g_flagcapture));
			
		}
		if ((iTeam == ALLIES) && (g_teamvalueALL > 0))
		{
			g_teamvalueALLIES = (g_teamvalueALLIES + GetConVarInt(g_flagcapture));
			PrintToChatAll("%t", "flagcap_axis", g_sPrefix, GetConVarInt(g_flagcapture));
		}
	}
	return Plugin_Continue;
}

CleanUp()
{  // By Kigen (c) 2008 - Please give me credit. :)
	new maxent = GetMaxEntities(), String:name[64];
	for (new i = GetMaxClients(); i < maxent; i++)
	{
		if (IsValidEdict(i) && IsValidEntity(i))
		{
			GetEdictClassname(i, name, sizeof(name));
			if ((StrContains(name, "weapon_") != -1 || StrContains(name, "item_") != -1) && GetEntDataEnt2(i, g_WeaponParent) == -1)
				//RemoveEdict(i);
			AcceptEntityInput(i, "kill");
		}
	}
}

public IsValidClient(client)
{
	if (!(1 <= client <= MaxClients) || !IsClientInGame(client))
		return false;
	
	return true;
}


public Action:NoWeaponCheck_CLIP(Handle:timer, any:client)
{
	if (IsClientInGame(client) && IsPlayerAlive(client))
	{
		new weapons = 0;
		for (new slot = 0; slot <= 4; slot++)
		{
			if (GetPlayerWeaponSlot(client, slot) != -1)
			{
				weapons++;
			}
		}
		if (weapons == 0)
		{
			GivePlayerItem(client, "weapon_thompson");
			PrintToChat(client, " !!!! SORRY - YOU FOUND THE WEAPON BUG !!!! ");
			LogMessage("GG Weapon Bug - CLIP !!");
		}
	}
} 